//
// Generated by Microsoft (R) D3DX9 Shader Compiler 9.08.299.0000
//
//   vsa shaderdump19/WATER000.pso /Fcshaderdump19/WATER000.pso.dis
//
//
// Parameters:
//
float4 FogParam : register(c9);
sampler2D NormalMap : register(s1);

float4 glob_fogColor : register(c20);
float4 glob_waterCoefficients : register(c21);
float4 glob_waveParams : register(c22);
float4 glob_waterVolume : register(c23);
float4 cust_foamColor : register(c24);
float4 glob_foamAndLODSettings : register(c25);
float4 oblv_ReciprocalResolution_CURRENTPASS : register(c26);

matrix oblv_ViewTransform_CURRENTPASS : register(c27);
matrix oblv_ProjectionTransform_CURRENTPASS : register(c31);

static const float nearZ = oblv_ProjectionTransform_CURRENTPASS._34 / oblv_ProjectionTransform_CURRENTPASS._33;
static const float farZ = (oblv_ProjectionTransform_CURRENTPASS._33 * nearZ) / (oblv_ProjectionTransform_CURRENTPASS._33 - 1.0f);
static const float Zmul = nearZ * farZ;
static const float Zdiff = farZ - nearZ;
static const float depthRange = nearZ - farZ;

static const matrix <float, 4, 4> ditherMat = {
	0.0588, 0.5294, 0.1765, 0.6471,
	0.7647, 0.2941, 0.8824, 0.4118,
	0.2353, 0.7059, 0.1176, 0.5882,
	0.9412, 0.4706, 0.8235, 0.3259
};

// Structures:

struct VS_OUTPUT {
    float3 texcoord_0 : TEXCOORD0_centroid;
    float3 texcoord_1 : TEXCOORD1_centroid;
    float4 texcoord_2 : TEXCOORD2_centroid;
    float4 texcoord_3 : TEXCOORD3_centroid;
    float4 texcoord_4 : TEXCOORD4_centroid;
    float4 texcoord_5 : TEXCOORD5_centroid;
    float4 texcoord_6 : TEXCOORD6;
};

struct PS_OUTPUT {
    float4 color_0 : COLOR0;
};

// Code:
float3 toWorld(float2 tex)
{
    float3 v = float3(oblv_ViewTransform_CURRENTPASS[2][0], oblv_ViewTransform_CURRENTPASS[2][1], oblv_ViewTransform_CURRENTPASS[2][2]);
    v += ( 1/oblv_ProjectionTransform_CURRENTPASS[0][0] * (2*tex.x-1)).xxx * float3(oblv_ViewTransform_CURRENTPASS[0][0], oblv_ViewTransform_CURRENTPASS[0][1], oblv_ViewTransform_CURRENTPASS[0][2]);
    v += (-1/oblv_ProjectionTransform_CURRENTPASS[1][1] * (2*tex.y-1)).xxx * float3(oblv_ViewTransform_CURRENTPASS[1][0], oblv_ViewTransform_CURRENTPASS[1][1], oblv_ViewTransform_CURRENTPASS[1][2]);
    return v;
}

float3 getWaterNorm( float2 tex, float dist, float camera_vector_z, inout float3 specNorm )
{
	float choppiness = glob_waveParams.x;
	float waveWidth = glob_waveParams.y;
	float LODdistance = glob_foamAndLODSettings.z;
	float MinLOD = glob_foamAndLODSettings.w;

	float lod = max( saturate( (camera_vector_z*camera_vector_z) * 50 * oblv_ProjectionTransform_CURRENTPASS[0][0] /(oblv_ReciprocalResolution_CURRENTPASS.x * dist) * LODdistance ), MinLOD);
	float2 Coord = tex / (1024 * waveWidth);

	float4 sampledResult = tex2Dlod( NormalMap, float4(Coord,0,0)  );

	float2 temp_norm = sampledResult.rg * 2 - 1;
	float3 norm = normalize(float3(temp_norm * choppiness * lod,1));
	specNorm = normalize(float3(temp_norm * choppiness * max(0.5, lod), 1));
	return norm;
}

float getFresnelAboveWater( float3 ray, float3 norm )
{
	float temp_cos = dot( -ray, norm );
	float2 vec = float2(temp_cos, sqrt(1-temp_cos*temp_cos));

	float fresnel = vec.x - 1.33 * sqrt(1 - 0.565*vec.y*vec.y);
	fresnel /= vec.x + 1.33 * sqrt(1 - 0.565*vec.y*vec.y);
	fresnel = saturate(fresnel * fresnel);

	return fresnel;
}


PS_OUTPUT main(VS_OUTPUT IN, float2 PixelPos : VPOS) {
    PS_OUTPUT OUT;

	float2 UVCoord = (PixelPos+0.5)*oblv_ReciprocalResolution_CURRENTPASS.xy;
	float3 eyepos = IN.texcoord_2.xyz;
	eyepos.z = -IN.texcoord_1.z;

    float3 camera_vector = toWorld(UVCoord);
	float3 norm_camera_vector = normalize( camera_vector );

	float4 FogColor = glob_fogColor;
	float3 extCoeff = glob_waterCoefficients.xyz;
	float scattCoeff = glob_waterCoefficients.w;
	float reflectivity = glob_waveParams.w;
	float waveWidth = glob_waveParams.y;

	float dist = eyepos.z / -camera_vector.z;
	float2 surfPos = eyepos.xy + camera_vector * dist;

	float3 normal = 0;
	float3 specNorm = float3(0,0,1);
	normal = getWaterNorm( surfPos, dist, -camera_vector.z, specNorm);

	//Calculate Refraction color
	float SinBoverSinA = -norm_camera_vector.z;
	float3 waterVolColor = scattCoeff * FogColor.xyz / ( extCoeff * (1 + SinBoverSinA) );

	float4 refract_color = float4( waterVolColor.rgb, 1 );

	//Calculate reflection color
	float4 reflection = FogColor;

	float fresnel = saturate( getFresnelAboveWater( norm_camera_vector, normal ) * reflectivity );
	float4 water_result = lerp( refract_color, reflection, fresnel );

	//Add above water fog
    float fog = 1 - saturate((FogParam.x - length(IN.texcoord_1.xyz)) / FogParam.y);
	water_result.rgb = (fog * (reflection.rgb - water_result.rgb)) + water_result.rgb;

	water_result.rgb += ditherMat[ PixelPos.x%4 ][ PixelPos.y%4 ] / 255;

	OUT.color_0.rgb = water_result.rgb;
	OUT.color_0.a = 1;

    return OUT;
};