//
// Generated by Microsoft (R) D3DX9 Shader Compiler 9.08.299.0000
//
//   psa shaderdump19/WATER006.pso /Fcshaderdump19/WATER006.pso.dis
//
//
// Parameters:
//
sampler2D DetailMap : register(s2);
sampler2D NormalMap : register(s1);
float2 Scroll : register(c0);
float4 SunDir : register(c2);
float4 VarAmounts : register(c8);

float4 glob_fogColor : register(c21);
float4 glob_sunColor : register(c22);
float4 glob_waterCoefficients : register(c23);
float4 glob_waveParams : register(c24);
float4 oblv_ReciprocalResolution_CURRENTPASS : register(c25);

matrix oblv_ViewTransform_CURRENTPASS : register(c26);
matrix oblv_ProjectionTransform_CURRENTPASS : register(c30);

//
//
// Default Registers:
//
//   Name            Reg   Size
//   --------------- ----- ----
//   Scroll          const_0       1
//   EyePos          const_1       1
//   SunDir          const_2       1
//   SunColor        const_3       1
//   ShallowColor    const_5       1
//   DeepColor       const_6       1
//   ReflectionColor const_7       1
//   VarAmounts      const_8       1
//   FogParam        const_9       1
//   FogColor        const_10      1
//   FresnelRI       const_11      1
//   NormalMap       texture_1       1
//   DetailMap       texture_2       1
//


// Structures:

struct VS_OUTPUT {
    float3 texcoord_1 : TEXCOORD1_centroid;
    float4 texcoord_2 : TEXCOORD2_centroid;
    float2 texcoord_6 : TEXCOORD6;
};

struct PS_OUTPUT {
    float4 color_0 : COLOR0;
};

float3 toWorld(float2 tex)
{
    float3 v = float3(oblv_ViewTransform_CURRENTPASS[2][0], oblv_ViewTransform_CURRENTPASS[2][1], oblv_ViewTransform_CURRENTPASS[2][2]);
    v += (1/oblv_ProjectionTransform_CURRENTPASS[0][0] * (2*tex.x-1)).xxx * float3(oblv_ViewTransform_CURRENTPASS[0][0], oblv_ViewTransform_CURRENTPASS[0][1], oblv_ViewTransform_CURRENTPASS[0][2]);
    v += (-1/oblv_ProjectionTransform_CURRENTPASS[1][1] * (2*tex.y-1)).xxx * float3(oblv_ViewTransform_CURRENTPASS[1][0], oblv_ViewTransform_CURRENTPASS[1][1], oblv_ViewTransform_CURRENTPASS[1][2]);
    return v;
}

float3 getWaterNorm( float2 tex, float dist, float camera_vector_z )
{
	float choppiness = glob_waveParams.x;

	float4 sampledResult = tex2D( NormalMap, tex  );

	float2 temp_norm = sampledResult.rg * 2 - 1;
	float3 norm = normalize(float3(temp_norm * choppiness, 1));
	return norm;
}

float getFresnelBelowWater( float3 ray, float3 norm )
{
	float temp_cos = dot( ray, norm );
	temp_cos = max(temp_cos, 0.659325);
	float2 vec = float2(temp_cos, sqrt(1-temp_cos*temp_cos));

	float fresnel = 1.33 * vec.x - sqrt(1 - 1.769*vec.y*vec.y);
	fresnel /= 1.33 * vec.x + sqrt(1 - 1.769*vec.y*vec.y);
	fresnel = saturate(fresnel * fresnel);

	return fresnel;
}

float getFresnelAboveWater( float3 ray, float3 norm )
{
	float temp_cos = dot( ray, norm );
	float2 vec = float2(temp_cos, sqrt(1-temp_cos*temp_cos));

	float fresnel = vec.x - 1.33 * sqrt(1 - 0.565*vec.y*vec.y);
	fresnel /= vec.x + 1.33 * sqrt(1 - 0.565*vec.y*vec.y);
	fresnel = saturate(fresnel * fresnel);

	return fresnel;
}

// Code:

PS_OUTPUT main(VS_OUTPUT IN, float2 PixelPos : VPOS) {
    PS_OUTPUT OUT;

	float2 UVCoord = (PixelPos+0.5)*oblv_ReciprocalResolution_CURRENTPASS.xy;
    float4 fogColor = glob_fogColor;
	float4 sunColor = glob_sunColor;
	float3 extCoeff = glob_waterCoefficients.xyz;
	float scattCoeff = glob_waterCoefficients.w;
	float waveWidth = glob_waveParams.y;
	bool lava = (VarAmounts.w > 0.4);

    float3 camera_vector = toWorld(UVCoord);
	float3 norm_camera_vector = normalize( camera_vector );
	float3 eyepos = IN.texcoord_2.xyz;
	eyepos.z = -IN.texcoord_1.z;

	float uw_pos = abs( eyepos.z / camera_vector.z );
	float2 surfPos = eyepos.xy + camera_vector.xy * uw_pos;
	float3 normal = getWaterNorm( surfPos / (1024 * waveWidth), uw_pos, camera_vector.z );

	//Specular effects
	float specular = saturate(dot( float3(1,1,-1)*norm_camera_vector, reflect( SunDir.xyz, normal) ));
	specular = pow(specular, 750);

	//Fresnel effects
	float4 reflection = float4( scattCoeff * fogColor.xyz / extCoeff, 1);
	reflection *= lerp( 1, 1.5, getFresnelAboveWater( norm_camera_vector, normal ) );
	float fresnel = getFresnelBelowWater( norm_camera_vector, normal );
	
	specular *= 1-fresnel;
	OUT.color_0.rgb = lerp( reflection, 10 * sunColor.xyz, specular ).rgb;

	float visibility = saturate(0.001 + fresnel + specular*length(sunColor.xyz) );
	if (lava)
	{
			OUT.color_0.rgb = tex2D(DetailMap, IN.texcoord_6.xy + Scroll.xy).rgb;
			OUT.color_0.r += 0.6;
			visibility = 1;
	}

	OUT.color_0.a = visibility;

    return OUT;
};

// approximately 59 instruction slots used (2 texture, 57 arithmetic)
