//
// Generated by Microsoft (R) D3DX9 Shader Compiler 9.08.299.0000
//
//   vsa shaderdump19/WATER000.pso /Fcshaderdump19/WATER000.pso.dis
//
//
// Parameters:
//
float4 FogColor : register(c10);
float4 FogParam : register(c9);
sampler2D NormalMap : register(s1);
float2 Scroll : register(c0);
float4 SunDir : register(c2);

float glob_waveSpeed : register(c18);
float4 obge_Tick : register(c19);
texture2D cust_texWater < string filename = "effects\water_NRM_LOD.dds"; >;
sampler2D cust_samplerWater : register(s6) = sampler_state
{
    Texture = <cust_texWater>;
    AddressU  = WRAP;
    AddressV  = WRAP;
    AddressW  = WRAP;
    MIPFILTER = LINEAR;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

float4 glob_sunColor : register(c20);
float4 glob_waterCoefficients : register(c21);
float4 glob_waveParams : register(c22);
float4 cust_foamColor : register(c24);
float4 glob_foamAndLODSettings : register(c25);
float4 oblv_ReciprocalResolution_CURRENTPASS : register(c26);

matrix oblv_ViewTransform_CURRENTPASS : register(c27);
matrix oblv_ProjectionTransform_CURRENTPASS : register(c31);

static const float nearZ = oblv_ProjectionTransform_CURRENTPASS._34 / oblv_ProjectionTransform_CURRENTPASS._33;
static const float farZ = (oblv_ProjectionTransform_CURRENTPASS._33 * nearZ) / (oblv_ProjectionTransform_CURRENTPASS._33 - 1.0f);
static const float Zmul = nearZ * farZ;
static const float Zdiff = farZ - nearZ;
static const float depthRange = nearZ - farZ;

static const matrix <float, 4, 4> ditherMat = { 0.0588, 0.5294, 0.1765, 0.6471,
												0.7647, 0.2941, 0.8824, 0.4118,
												0.2353, 0.7059, 0.1176, 0.5882,
												0.9412, 0.4706, 0.8235, 0.3259 };

//
//
// Registers:
//
//   Name            Reg   Size
//   --------------- ----- ----
//   Scroll          const_0       1
//   EyePos          const_1       1
//   SunDir          const_2       1
//   SunColor        const_3       1
//   ShallowColor    const_5       1
//   DeepColor       const_6       1
//   ReflectionColor const_7       1
//   VarAmounts      const_8       1
//   FogParam        const_9       1
//   FogColor        const_10      1
//   FresnelRI       const_11      1
//   ReflectionMap   texture_0       1
//   NormalMap       texture_1       1
//   DetailMap       texture_2       1
//   DepthMap        texture_3       1
//


// Structures:

struct VS_OUTPUT {
    float3 texcoord_0 : TEXCOORD0_centroid;
    float3 texcoord_1 : TEXCOORD1_centroid;
    float4 texcoord_2 : TEXCOORD2_centroid;
    float4 texcoord_3 : TEXCOORD3_centroid;
    float4 texcoord_4 : TEXCOORD4_centroid;
    float4 texcoord_5 : TEXCOORD5_centroid;
    float4 texcoord_6 : TEXCOORD6;
};

struct PS_OUTPUT {
    float4 color_0 : COLOR0;
};

// Code:
float3 toWorld(float2 tex)
{
    float3 v = float3(oblv_ViewTransform_CURRENTPASS[2][0], oblv_ViewTransform_CURRENTPASS[2][1], oblv_ViewTransform_CURRENTPASS[2][2]);
    v += (1/oblv_ProjectionTransform_CURRENTPASS[0][0] * (2*tex.x-1)).xxx * float3(oblv_ViewTransform_CURRENTPASS[0][0], oblv_ViewTransform_CURRENTPASS[0][1], oblv_ViewTransform_CURRENTPASS[0][2]);
    v += (-1/oblv_ProjectionTransform_CURRENTPASS[1][1] * (2*tex.y-1)).xxx * float3(oblv_ViewTransform_CURRENTPASS[1][0], oblv_ViewTransform_CURRENTPASS[1][1], oblv_ViewTransform_CURRENTPASS[1][2]);
    return v;
}

float readDepth(in float2 coord : TEXCOORD0)
{
	float posZ = 1;
	posZ = Zmul / ((posZ * Zdiff) - farZ);

	return posZ;
}

#define animFrames 32
float2 get2DTex( float3 tex )
{
	float2 return_tex = float2(0, tex.y);
	return_tex.x = frac(tex.x)/animFrames + round( tex.z*(animFrames) )/animFrames;
	return return_tex;
}

float3 getWaterNorm( float2 tex, float dist, float camera_vector_z, inout float3 specNorm )
{
	float choppiness = glob_waveParams.x;
	float waveWidth = glob_waveParams.y;
	float LODdistance = glob_foamAndLODSettings.z;
	float MinLOD = glob_foamAndLODSettings.w;

	float lod = max( saturate( (camera_vector_z*camera_vector_z) * 50 * oblv_ProjectionTransform_CURRENTPASS[0][0] /(oblv_ReciprocalResolution_CURRENTPASS.x * dist) * LODdistance ), MinLOD);
	float2 Coord = tex / (1024 * waveWidth);

	float frame = obge_Tick.y * glob_waveSpeed / 1500;
	float2 newCoord = get2DTex( float3(frac(Coord), frac(frame)) );
	float4 sampledResult = tex2D( cust_samplerWater, newCoord );

	float2 temp_norm = sampledResult.rg * 2 - 1;
	float3 norm = normalize(float3(temp_norm * choppiness * lod,1));
	specNorm = normalize(float3(temp_norm * choppiness * max(0.5, lod), 1));
	return norm;
}

float getFresnelAboveWater( float3 ray, float3 norm )
{
	float temp_cos = dot( -ray, norm );
	float2 vec = float2(temp_cos, sqrt(1-temp_cos*temp_cos));

	float fresnel = vec.x - 1.33 * sqrt(1 - 0.565*vec.y*vec.y);
	fresnel /= vec.x + 1.33 * sqrt(1 - 0.565*vec.y*vec.y);
	fresnel = saturate(fresnel * fresnel);

	return fresnel;
}


PS_OUTPUT main(VS_OUTPUT IN, float2 PixelPos : VPOS) {
    PS_OUTPUT OUT;

	float2 UVCoord = (PixelPos+0.5)*oblv_ReciprocalResolution_CURRENTPASS.xy;
	float3 eyepos = IN.texcoord_2.xyz;
	eyepos.z = -IN.texcoord_1.z;

    float depth = readDepth(UVCoord);
    float3 camera_vector = toWorld(UVCoord);
	float3 norm_camera_vector = normalize( camera_vector );
    float3 world_pos = eyepos + camera_vector*depth;

	clip(-world_pos.z);

	float4 sunColor = glob_sunColor;
	float3 extCoeff = glob_waterCoefficients.xyz;
	float scattCoeff = glob_waterCoefficients.w;
	float reflectivity = glob_waveParams.w;
	float waveWidth = glob_waveParams.y;

	float uw_pos = world_pos.z / camera_vector.z;
	float2 surfPos = world_pos.xy - camera_vector.xy * uw_pos;

	float3 normal = 0;
	float3 specNorm = float3(0,0,1);
	normal = getWaterNorm( surfPos, depth - uw_pos, -camera_vector.z, specNorm);

	float4 refract_color = 1;
	float3 refract_world_pos = world_pos;
	float2 refPos = UVCoord;

	//Calculate Refraction color
	float refract_uw_pos = refract_world_pos.z / camera_vector.z;
    refract_color.rgb *= 0;//exp( -extCoeff * (refract_uw_pos - refract_world_pos.z) / 70 );

	float SinBoverSinA = -norm_camera_vector.z;
	float3 waterVolColor = scattCoeff * FogColor.xyz / ( extCoeff * (1 + SinBoverSinA) );

	refract_color.rgb += waterVolColor;

	//Calculate reflection color
	float4 reflection = FogColor;

	float fresnel = saturate( getFresnelAboveWater( norm_camera_vector, normal ) * reflectivity );
	float4 water_result = lerp( refract_color, reflection, fresnel );

	float specular = saturate(dot( norm_camera_vector, reflect( SunDir.xyz, specNorm ) ));
	water_result.xyz += 4*pow(specular, (depth-uw_pos)*0.3 + 750) * sunColor.xyz;

	//Add above water fog
    float fog = 1 - saturate((FogParam.x - length(IN.texcoord_1.xyz)) / FogParam.y);
	water_result.rgb = (fog * (reflection.rgb - water_result.rgb)) + water_result.rgb;

	water_result.rgb += ditherMat[ PixelPos.x%4 ][ PixelPos.y%4 ] / 255;

	OUT.color_0.rgb = water_result.rgb;
	OUT.color_0.a = 1;

    return OUT;
};

// approximately 84 instruction slots used (4 texture, 80 arithmetic)
